# UploadPart

Retains part of the object.

The user independently numbers the parts of the object and transfers the numbers to ColdStack. The number uniquely identifies the part and determines its order in the overall sequence. A number is an integer between 1 and 10,000, inclusive.

If multiple chunks with the same number are loaded, ColdStack retains the last one that arrived.

Each part, except the last, must be at least 5MB in size.

For more information, see [General Multipart Upload Procedure](/http-api-compatible-with-amazon-s3/api-reference/multipart-upload/general-multipart-upload-order.md) .

### Request <a href="#request" id="request"></a>

```
PUT /{bucket}/{key}?partNumber=PartNumber&uploadId=UploadId HTTP/1.1
```

#### Path parameters <a href="#path-parameters" id="path-parameters"></a>

| Parameter | Description  |
| --------- | ------------ |
| `bucket`  | Bucket name. |
| `key`     | Object key.  |

#### Query parameters <a href="#request-parameters" id="request-parameters"></a>

| Parameter    | Description                                                                                                                                              |
| ------------ | -------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `partNubmer` | The ID that you assigned to the downloadable part.                                                                                                       |
| `uploadId`   | The composite load ID that ColdStack returned upon [initialization](/http-api-compatible-with-amazon-s3/api-reference/multipart-upload/startupload.md) . |

#### Headings <a href="#request-headers" id="request-headers"></a>

Use the required [common headers](/http-api-compatible-with-amazon-s3/api-reference/common-request-headers.md) in the request .

The title is `Content-Length`required.

### Answer <a href="#response" id="response"></a>

#### Headings <a href="#response-headers" id="response-headers"></a>

The response can contain [general headers](/http-api-compatible-with-amazon-s3/api-reference/common-response-headers.md) and the headers listed in the table below.

| Heading               | Description                                                                                                                                                                    |
| --------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `x-amz-storage-class` | <p>Object storage class.<br>Matters <code>COLD</code>if the object is in Cold Storage.<br><br>If the object is saved in the Standard storage, then there will be no title.</p> |

#### Answer codes <a href="#response-codes" id="response-codes"></a>

For a list of possible answers, see the [Answers](/http-api-compatible-with-amazon-s3/api-reference/answers.md) section .

Additionally, ColdStack may return the errors described in the table below.

| Mistake          | Description                                                                                                                  | HTTP code       |
| ---------------- | ---------------------------------------------------------------------------------------------------------------------------- | --------------- |
| `NoSuchUpload`   | The specified download does not exist. The download ID may be incorrect, or the download may have completed or been deleted. | 404 Not Found   |
| `EntityTooSmall` | <p>Part size is too small.<br><br>The downloadable part must be at least 5MB.</p>                                            | 400 Bad Request |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.coldstack.io/http-api-compatible-with-amazon-s3/api-reference/multipart-upload/uploadpart.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
